<html>
  <head>
      <meta charset="UTF-8">
      <!--<base target="_blank"/>-->
      <script src="./lib/jquery.min.js"></script>
      <script src="./lib/d3.v4.min.js"></script>
      <style>
      .ajaxLoading {
        cursor: progress !important;
      }

      </style>

      <script>

      $(document).ajaxStart(function(){
        $("body").addClass('ajaxLoading');
      });
      $(document).ajaxStop(function(){
        $("body").removeClass('ajaxLoading');
      });

      var tooltip={};

      function drawGraph(svg,baseH,H,W,values,acc){
          var margin = {
                        top: 20,
                        right: 50,
                        bottom: 30,
                        left: 50
                      },
                      width = W - margin.left - margin.right,
                      height = H - margin.top - margin.bottom;
                      baseW=margin.left;

                    var x = d3.scaleLinear().range([baseW, baseW+width]);
                    var y = d3.scaleLinear().range([baseH+height, baseH]);
                    x.domain([0, values.length-1]);
                    y.domain([0, +1]);
                    // Add the X Axis
                    svg.append("g")
                      .attr("transform", "translate("+(0)+"," + (baseH+height) + ")")
                      .call(d3.axisBottom(x));
                    // Add the Y Axis
                    svg.append("g")
                      .attr("transform", "translate("+(baseW)+"," + 0 + ")")
                      .call(d3.axisLeft(y));

                    var valueline = d3.line()
                            .x(function(d) {
                                  return x(+d.index);
                              })
                            .y(function(d) {
                                   return (y(+d.value));
                             });
                  // Add the valueline path.
                  svg.append("path")
                         .data([values])
                         .attr("class", "line")
                         .style("stroke", 'blue')
                         .style("stroke-width", 2)
                         .style('fill','none')
                         .attr("d", valueline);
                 svg.append("text")
                    .attr("transform", "translate("+(width+10)+",20)")
                    .style("text-anchor", "right")
                    .style("font-size", 10)
                    .style('fill','green')
                    .text('No loss');
                 svg.append("text")
                    .attr("transform", "translate("+(width+10)+",30)")
                   .style("text-anchor", "right")
                   .style("font-size", 10)
                   .style('fill','orange')
                   .text('5% loss');
                svg.append("text")
                    .attr("transform", "translate("+(width+10)+",40)")
                    .style("text-anchor", "right")
                    .style("font-size", 10)
                    .style('fill','red')
                    .text('10% loss');

                  graphAddLine(svg,acc,'green');
                  graphAddLine(svg,0.95*acc,'orange');
                  graphAddLine(svg,0.9*acc,'red');

          function graphAddLine(svg,acc,color)          {
            svg.append("rect")
               .attr("class", "accLine")
               .style('fill',color)
               .attr("x", x(0))
               .attr("y", y(acc))
               .attr("width", width)
               .attr("height", 0.1)
               .style('stroke-dasharray',"1,1")
               .style('stroke',function(d){
                      return(color);
                });
            var ind=lastIndexGT(values,acc);
            svg.append("rect")
               .attr("class", "accLine")
               .style('fill',color)
               .attr("x", x(ind))
               .attr("y", y(1))
               .attr("width", 0.1)
               .attr("height", height)
               .style('stroke-dasharray',"1,1")
               .style('stroke',function(d){
                     return(color);
               });
            svg.append("text")
               .attr("transform", "translate("+x(ind)+","+(y(0)+30)+")")
               .style("text-anchor", "middle")
               .style("font-size", 12)
               .style('fill',color)
               .text(ind);
             }
      }
      function lastIndexGT(values,val){
        var ind=0;
        for (ind=0;values[ind].value>=val;ind++){}
        return(ind-1);
      }
      function drawnodes(svg,baseW,W,baseH,H,values,cs,acc){
        var margin = {top: 20, right: 20, bottom: 20, left: 20};
        var N = Math.floor(Math.sqrt(values.length/Math.floor(W/H)));
        var X = Math.min(Math.floor(H/(2*N)),Math.floor(W/(2*(values.length/N))));
        N=Math.floor(W/(2*X));
        var x = d3.scaleLinear().range([baseW+margin.left, baseW+W-margin.right]);
        values.forEach(function(d){d.value=d.value-acc});
        var ext=d3.extent(values, function(d) { return d.value; });
        if (ext[0]==ext[1]){
          ext[1]=Math.min(1,ext[1]+0.1*ext[1]);
          ext[0]=ext[0]-0.1*ext[0];
        }
        x.domain(ext);
        //x.domain([-0.01, 0.01]);
        var simulation = d3.forceSimulation(values)
                            .force("x", d3.forceX(function(d) { return x(d.value); }).strength(1))
                            .force("y", d3.forceY(H/2))
                            .force("collide", d3.forceCollide((3600-3*(values.length))/600))
                            .stop();

        for (var i = 0; i < 200; ++i) simulation.tick();


        svg.append("g")
           .attr("class", "axis axis--x")
           .attr("transform", "translate(0," + (baseH+H) + ")")
           .call(d3.axisBottom(x).ticks(10, ".5"));
        svg.append("text")
           .attr("transform", "translate("+(W/2)+",40)")
           .style("text-anchor", "middle")
           .style("font-size", 16)
           .text('Effect of a single removal in the accuracy');

        var cell = svg.append("g")
                      .attr("class", "cells")
                      .selectAll("g").data(d3.voronoi()
                      .extent([[0, 0], [W, H]])
                      .x(function(d) { return d.x; })
                      .y(function(d) { return d.y; })
                      .polygons(values)).enter().append("g");

        cell.append("circle")
            .attr("r", Math.max(2.0,(3300-3*(values.length))/600))
            .attr("cx", function(d) {
              if (typeof d != 'undefined'){
                return d.data.x;
              }
              return(-100);
            })
            .attr("cy", function(d) {
              if (typeof d != 'undefined'){
                return baseH+d.data.y;
              }
              return(-100);
            });
      }
      function drawLayers(data,acc){
        var cs = d3.scaleLinear()
                .domain([0.0, acc])
                .range(["gray", "green"]);

        d3.select('#layers').selectAll('svg').remove();
        var w=document.getElementById('layers').offsetWidth;
        var h=document.getElementById('layers').offsetHeight;
        var svg = d3.select('#layers').append("svg")
                .attr("width", w)
                .attr("height", h)
                .append("g");

        var step=Math.max(150,h/(data.length+0.5));
        var svgG = d3.select('#graphs').append("svg")
                    .attr("width", document.getElementById('graphs').offsetWidth)
                    .attr("height",document.getElementById('graphs').offsetHeight)
                    .append("g");
        svgG.append("text")
                    .attr("transform", "translate("+(document.getElementById('graphs').offsetWidth/2)+",40)")
                    .style("text-anchor", "middle")
                    .style("font-size", 16)
                    .text('Number of removed inputs versus Accuracy');

        var labelsSVG = d3.select('#labels').append("svg")
                    .attr("width", document.getElementById('labels').offsetWidth)
                    .attr("height",document.getElementById('labels').offsetHeight)
                    .append("g");


        console.log(data);
        svg.selectAll("baseRect")
                .data(data)
                .enter()
                .append("rect")
                .attr("class", "baseRect")
                .style('fill',function(d){
                  return('none');
                })
                .attr("x", function(d) {
                     return (0.05*w);
                 })
                .attr("y", function(d) {
                     return (parseFloat(d['index'])*step+step/4);
                })
               .attr("width", 0.9*w)
               .attr("height", 0.8*step)
               .style('stroke',function(d){
                  drawnodes(svg,
                    this.x.baseVal.value,
                    0.9*w,
                    this.y.baseVal.value,
                    0.8*step,
                    d['values'],cs,acc);
                  drawGraph(svgG,this.y.baseVal.value,
                    step,document.getElementById('graphs').offsetWidth,
                    d['cummulative'],acc);
                  return('gray');
                });

       labelsW=document.getElementById('labels').offsetWidth;
       labelsSVG.selectAll("nameline")
             .data(data)
             .enter()
             .append("text")
             .style('text-anchor','middle')
             .attr("class", "nameline")
             .attr("x", function(d) {
                    return (labelsW/2);
                })
             .attr("y", function(d) {
                  return (parseFloat(d['index'])*step+step/4+0.40*step);
             })
             .text(function(d) {
                  return('Name: '+d['name'])
             });
         labelsSVG.selectAll("nameline")
              .data(data)
              .enter()
              .append("text")
              .style('text-anchor','middle')
              .attr("class", "nameline")
              .attr("x", function(d) {
                     return (labelsW/2);
                 })
              .attr("y", function(d) {
                   return (parseFloat(d['index'])*step+step/4+0.40*step+20);
              })
              .text(function(d) {
                   return(d['numel']+' inputs.')
              });

      }
      function loadData(jsonfile){
        $.getJSON(jsonfile, function(json) {
          console.log(json);
          drawLayers(json.scopes,json.trainedAcc)
          tooltip = d3.select("body").append("div")
              .attr("class", "tooltip")
              .style("position",'absolute')
              .style("background-color", "lightblue")
              .style("padding",'5px')
              .style("border-radius","25px")
              .style("opacity", 0);
        // var w=document.getElementById('network').offsetWidth;
        // var h=document.getElementById('network').offsetHeight;
        // var svg = d3.select('#network').append("svg")
        //             .attr("width", w)
        //             .attr("height", h)
        //             .append("g");
        // drawGraph(svg,20,h-20,w,json.network,json.trainedAcc);
        });
      }
      </script>
  </head>
  <body onload="loadData('data.json')" >
    <!--<div id='network' style='width:99%;height:30%;margin:2;border-width: thin;  border: solid;  border-color: lightgray; '></div>-->
    <div style='display:flex'>
      <div id='layers' style='width:44%;margin:2;height:98%;border-width: thin;  border: solid;  border-color: lightgray; '></div>
      <div id='labels' style='width:10%;margin:2;height:98%;border-width: thin;  border: solid;  border-color: lightgray; '></div>
      <div id='graphs' style='width:44%;margin:2;height:98%;border-width: thin;  border: solid;  border-color: lightgray; '></div>
  </div>
  </body>
</html>
